function getCellLinks(doc, objName, banBMD, banUrl, banTit)	// 获取存在事件的标签页，和A链接
{
	if(!doc)
		return [];
	var wW			= doc.documentElement.clientWidth,		// 可视区宽度(不含滚动条)
		wH			= doc.documentElement.clientHeight;		// 可视区高度(不含滚动条)
	var ret			= [];
	var objs		= doc.getElementsByTagName(objName);	// 如 td table 等
	var domain		= (objName=='a') ? getDomain(doc.location.href) : '';
	for (var i=0; i<objs.length; i++)
	{
		var rc	= objs[i].getBoundingClientRect();
		if( (rc.right  < 0) || (rc.bottom < 0) || (rc.left > wW) ||	(rc.top  > wH) || rc.width==0 || rc.height==0)
			continue;
		else
		{
			objs[i]._top	= (rc.top<0)	?( 0):(rc.top);
			objs[i]._right	= (rc.right>wW)	?(wW):(rc.right);
			objs[i]._bottom	= (rc.bottom>wH)?(wH):(rc.bottom);
			objs[i]._left	= (rc.left<0)	?( 0):(rc.left);
		}

		var j	= 0;
		if(objName=='a')
		{
			if(domain == getDomain(objs[i].href))	// 外部链接
				continue;
			var is_ok	= (banBMD==1)?false:true;
			
			if(banUrl && banUrl.length>0)	// 客户网址黑白名单
			{
				for( j=0; j<banUrl.length; j++)
				{
					if(objs[i].href.indexOf(banUrl[j])>=0)	// 匹配到了
					{
						is_ok	= (banBMD==1)?true:false;
						break;
					}
				}
			}
			
			if(banTit && banTit.length>0)	// 客户标题黑白名单
			{
				var mch_tit	= removeHTMLTag(objs[i].text);	// 过滤回车、空格等
				for( j=0; j<banTit.length; j++)
				{
					if(mch_tit.indexOf(banTit[j])>=0)
					{
						is_ok	= (banBMD==1)?true:false;
						break;
					}
				}
			}
			
			if(is_ok==true)
			for( j=0; j<ptIllicitSuffix.length; j++)	// 屏蔽非法后缀
			{
				var cell_len	= ptIllicitSuffix[j].length;
				var cell_url	= objs[i].href.substr(objs[i].href.length - cell_len, cell_len);
				if( cell_url.toLowerCase() == ptIllicitSuffix[j].toLowerCase() )
				{
					is_ok	= false;
					break;
				}
			}

			if(is_ok==true)
			for( j=0; j<ptIllicitPrefix.length; j++)	// 屏蔽非法前缀
			{
				if( objs[i].href.indexOf(ptIllicitPrefix[j])==0)
				{
					is_ok	= false;
					break;
				}
			}
			
			if(is_ok == true)
			{
				objs[i].target	= '_blank';
				ret.push( objs[i] );
			}
		}
		else if	(objName=='input' && objs[i].getAttribute('type')=='submit')
			ret.push( objs[i] );
		else if
		(
				objs[i].onclick		||
				objs[i].onmousedown	||
				objs[i].onmousemove	||
				objs[i].onmouseout	||
				objs[i].onmouseover	||
				objs[i].onmouseup	||
				objs[i].onfocus
		)
			ret.push( objs[i] );
	};
	
	return ret;
};



function getExtLinks(doc, banBMD, banUrl, banTit)	// 获取外部链接
{
	var objs		= [];
	var objNames	= ['a', 'td', 'img', 'div', 'nobr', 'span', 'param'/*, 'input'*/];
	for(var i=0; i<objNames.length; i++)
	{
		var cell_obj	= getCellLinks(doc, objNames[i], banBMD, banUrl, banTit);
		for(var j=0; j<cell_obj.length; j++)
			objs.push( cell_obj[j] );
	}
	//f_logs('cellLinks.txt', var_dump_ergodic(objs));
	return objs;
};


function gaussian_random(min, max)				// 随机数函数，使用正态分布(高斯分布)
{
	var rd	= Math.sin(Math.random() * Math.PI / 2);
	return min + (max-min) * rd;
};

function sideRcPoint(top, right, bottom, left)	// 返回定位于矩形内且靠边0-adsorb像素的任意一点
{
	var adsorb	= 4;	// 吸附距离
	var fh_x	= (parseInt(Math.random()*10000)%2==1)?(1):(-1);
	var fh_y	= (parseInt(Math.random()*10000)%2==1)?(1):(-1);
	var md_x	= ((right - left)/2 > adsorb)?(gaussian_random(0, adsorb)):(gaussian_random(0, parseInt((right - left)/2)));
	var md_y	= ((bottom - top)/2 > adsorb)?(gaussian_random(0, adsorb)):(gaussian_random(0, parseInt((bottom - top)/2)));
	var x		= (fh_x==-1) ? gaussian_random(top, top + md_y) : gaussian_random(bottom - md_y, bottom);
	var y		= (fh_y==-1) ? gaussian_random(left, left + md_x): gaussian_random(right - md_x, right);
	return	{x:x, y:y};
};

function inRcPoint(top, right, bottom, left)	// 定位于矩形内的任意一点
{
	var	x	= gaussian_random(top, bottom);
	var y	= gaussian_random(left, right);
	return {x:x, y:y};
};

function rcSide2Inside(obj)	// 一个矩形，从边上的point到内部的point，返回array(from_x, from_y, to_x, to_y)
{
	if(!obj._top)
		initObjPosition(obj);

	var fm	= sideRcPoint	(obj._top, obj._right, obj._bottom, obj._left);
	var to	= inRcPoint		(obj._top, obj._right, obj._bottom, obj._left);
	return {fm_x: fm.x, fm_y: fm.y, to_x: to.x, to_y: to.y };
};

function rcSide2Side(obj)	// 一个矩形，从边上的point到边上的point，返回array(from_x, from_y, to_x, to_y)
{
	if(!obj)
		return null;
	if(!obj._top)
		initObjPosition(obj);
	var fm	= sideRcPoint(obj._top, obj._right, obj._bottom, obj._left);
	var to	= sideRcPoint(obj._top, obj._right, obj._bottom, obj._left);
	return {fm_x: fm.x, fm_y: fm.y, to_x: to.x, to_y: to.y };
};

function getDistance(fm, to)		// 距离
{
	var x	= Math.abs(fm.x - to.x);
	var y	= Math.abs(fm.y - to.y);
	return Math.sqrt( Math.pow(x, 2) + Math.pow(y, 2) );
};

function makeTimeSequence(endtime)	// 产生(行为)时序
{
	var ret		= [];
	var end		= (endtime - 1 ) *1000;
	ret[0]		= gaussian_random(end * 0.2, end * 0.4);
	for(;;)
	{
		var next	= ret[ret.length -1 ] + gaussian_random(700, end * 0.25);
		if(next>=end)
			break;
		ret[ret.length]	= next;
	}
	return ret;
};

function arrayRidBetween(arr, cnt)	// 去掉数组中间(不包含数组首尾)cnt个元素
{
	var arr_len	= arr.length;
	for(;;)
	{
		arr.splice(gaussian_random(1, arr.length -2), 1); 
		if(arr.length <= ( arr_len - cnt ) )
			break;
	}
	return arr;
};

function makeTimeTrajectory(time_len, screen_fm, fm, to)	// 产生轨迹，轨迹包含2个部分，时间和线，返回一个数组，表达某时间点内从起点到终点的轨迹
{
	var tm_grit		= 8;													// 时间粒度（毫秒）
	var tj_grit		= Math.round(getDistance(fm, to)/getRandom(10, 30));	// 轨迹粒度（像素）(至少1像素)
	if(tj_grit<3)	tj_grit = 3;
	
	// 把时间散开
	var tm_arr	= [0];
	var tm		= 0;
	for(;;)
	{
		tm	= tm + getRandom(4, tm_grit);
		if(tm>time_len)
			break;
		if(tm!=tm_arr[tm_arr.length - 1])
			tm_arr[tm_arr.length]	= tm;
	}
	
	// 产生轨迹
	var tj_arr		= new Array([0, 0]);	// 直线
	var x_len		= to.x - fm.x;
	var y_len		= to.y - fm.y;
	var abs_x_len	= Math.abs(x_len);
	var abs_y_len	= Math.abs(y_len);
	var x			= 0;
	var y			= 0;
	if(x_len!=0 && y_len!=0)
	for(;;)
	{
		if( abs_x_len >= abs_y_len)
		{
			if		(x_len>0)	// 从左到右
				x	= x	+ gaussian_random(1, tj_grit);
			else if	(x_len<0)	// 从右到左
				x	= x - gaussian_random(1, tj_grit);
			else
				x	= 0;
			y		= x * ( y_len / x_len );
			if(Math.abs(x) > abs_x_len)
				break;
		}
		else
		{
			if		(y_len>0)	// 从上到下
				y	= y + gaussian_random(1, tj_grit);
			else if	(y_len<0)	// 从下到上
				y	= y - gaussian_random(1, tj_grit);
			else
				y	= 0;
			x		= y * ( x_len / y_len );
			if(Math.abs(y) > abs_y_len)
				break;
		}
		if(x!=tj_arr[tj_arr.length -1][0] && y!=tj_arr[tj_arr.length -1][1])
			tj_arr[tj_arr.length]	= [x, y];
	}
	//return 0;
	
	// 使两个数组等长
	var len_sub	= tm_arr.length - tj_arr.length;
	//alert(tm_arr.length + '	xxxxxxxxxxx   ' + tj_arr.length);
	if(tm_arr.length>2 && tj_arr.length>2)	// 时间和轨迹的长度必须大于2
	{
		if(len_sub>0)
			arrayRidBetween(tm_arr, Math.abs(len_sub) );
		else if (len_sub<0)
			arrayRidBetween(tj_arr, Math.abs(len_sub) );
		//alert(tm_arr.length + '	xxxxxxxxxxx   ' + tj_arr.length);
		//document.write(tm_arr);
		//document.write(tj_arr);
		
		var ret	= [];
		for(var i=0; i<(Math.max(tm_arr.length, tj_arr.length)); i++)
		{
			ret[i]	= [Math.round( tm_arr[i] ), Math.round( screen_fm.x + fm.x + tj_arr[i][0] ), 	Math.round( screen_fm.y + fm.y + tj_arr[i][1]),
				  	   							Math.round( fm.x + tj_arr[i][0] ), 					Math.round( fm.y + tj_arr[i][1]) ];
		}
		if(ret.length>40)
			arrayRidBetween(ret, getRandom(10, 40) );
		return ret;
	}
	else // 否则，返回起点和终点
	{
		var ret	= new Array([0, 		Math.round( screen_fm.x + fm.x),	Math.round( screen_fm.y + fm.y),	Math.round( fm.x ), Math.round( fm.y) ], 
							[time_len,	Math.round( screen_fm.x + to.x), 	Math.round( screen_fm.y + to.y),	Math.round( to.x ), Math.round( to.y) ]
						);
		return ret;
	}
	/**/
};


//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//
//																				鼠标事件
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function topMouseEvent(doc, obj, type, point)	// 鼠标事件
{
	var event	= doc.createEvent('MouseEvents');
	var detail	= 1; // 点击次数
	event.initMouseEvent(type, true, true, window, detail, point[0], point[1], point[2], point[3], false, false, false, false, 0, null);
	obj.dispatchEvent(event);
};

function topFocusEvent(doc, obj, type)			// 输入焦点事件	http://msdn.microsoft.com/zh-cn/library/windows/apps/hh465790.aspx
{
	var event	= doc.createEvent('HTMLEvents');// 何以不能用FocusEvent，不解
	event.initEvent(type, true, false);
	obj.dispatchEvent(event);
};

function topMouserMoveIn(doc, obj, point)	// 鼠标移入
{
	topMouseEvent(doc, obj, 'mouseover',	point);
	topMouseEvent(doc, obj, 'mouseenter',	point);
	topMouseEvent(doc, obj, 'mousemove',	point);
};

function topMouserMoveOut(doc, obj, point)	// 鼠标移出
{
	topMouseEvent(doc, obj, 'mouseout',		point);
	topMouseEvent(doc, obj, 'mouseleave',	point);
};

function topMouserClick(doc, obj, point)		// 鼠标点击
{
	topMouseEvent(doc, obj, 'mousedown',	point);
	topFocusEvent(doc, obj, 'focus');					// 得到焦点
	topMouseEvent(doc, obj, 'mouseup',		point);
	topMouseEvent(doc, obj, 'click',		point);
	topFocusEvent(doc, obj, 'blur');					// 失去焦点
	topFocusEvent(doc, obj, 'focus');
	topMouseEvent(doc, obj, 'mouseout',		point);
	topMouseEvent(doc, obj, 'mouseleave',	point);
};

function topMouseMoveInside(doc, obj, point)	// 鼠标移动事件，与时序有关
{
	topMouseEvent(doc, obj, 'mousemove',	point);
};

function topThrough(doc, obj, tj)		// 鼠标穿过
{
	for(var i=0; i<tj.length; i++)
	{
		var point	= [tj[i][1], tj[i][2], tj[i][3], tj[i][4]];
		if		(i==0)	// 鼠标进入
			topMouserMoveIn(doc, obj, point);
		else if	(i==tj.length-1)// 鼠标移出
			topMouserMoveOut(doc, obj, point);
		else	// 内部移动
			topMouseMoveInside(doc, obj, point);
	}
};

function topEntry_Click(doc, obj, tj)	// 鼠标进入并点击
{
	for(var i=0; i<tj.length; i++)
	{
		var point	= [tj[i][1], tj[i][2], tj[i][3], tj[i][4]];
		if		(i==0)	// 鼠标进入
			topMouserMoveIn(doc, obj, point);
		else if	(i==tj.length-1)// 鼠标点击
		{
			//f_logs('click.txt', var_dump_ergodic( point ));
			topMouserClick(doc, obj, point);
		}
		else	// 内部移动
			topMouseMoveInside(doc, obj, point);
	}
};

function docAbsPosition()	// 获取文档绝对位置（文档起点，位于屏幕的位置）
{
	var aLeft	= window.mozInnerScreenX;
	var aTop	= 102;
	return {left: aLeft, top: aTop};
};

function scrollWithDocument(doc)	// 操作滚动条，返回滚动条左上脚
{
	var wW	= doc.documentElement.clientWidth,	// 可视区宽度(不含滚动条)
		wH	= doc.documentElement.clientHeight,	// 可视区高度(不含滚动条)
		dW	= doc.documentElement.scrollWidth,	// 文档内容宽度
		dH	= doc.documentElement.scrollHeight;	// 文档内容高度
	
	doc.documentElement.scrollTop	= (dH > wH)? (1 - Math.sqrt( Math.sqrt(Math.random() ) ) ) * (dH - wH) : (0);
	doc.documentElement.scrollLeft	= (dW > wW)? (1 - Math.sqrt( Math.sqrt(Math.random() ) ) ) * (dW - wW) : (0);
	//var scroll	= {top: doc.documentElement.scrollTop, left: doc.documentElement.scrollLeft};
	//return scroll;
};

function  mouseTimeutEvent(tab, type, lingerTime)	// 正式处理
{
	setTimeout(function()
	{
		// 找到合适的标签页
		if(tab==null)
			return;
		if(!tab.linkedBrowser)
			return;
		var doc	= tab.linkedBrowser.contentDocument;
		var glb	= ptOnlineTask[tab.ptSiteID];
		
		var screen_fm	= {x:topPosition.left, y:topPosition.top};
		//f_logs('timeSequence.txt', type + '_' + var_dump_ergodic(glb));
		
		if		(type==0)	// 第一次鼠标事件 && 顶层窗口  		=> 移动/可能要点击body
		{
			scrollWithDocument(doc);						// 滚动条
			var time_len	= getRandom(100, 600);			// 随机时间长度
			//var body		= getCellLinks(doc, 'body', 0, '', '');
			var body		= doc.getElementsByTagName('body')[0];
			var rc			= rcSide2Side(body);		// 从矩形边上的point到边上的point，返回array(from_x, from_y, to_x, to_y)
			if(rc!=null)
			{
				var fm			= {x: rc.fm_x, y: rc.fm_y};
				var to			= {x: rc.to_x, y: rc.to_y};
					
				var tj			= makeTimeTrajectory(time_len, screen_fm, fm, to);		// 产生时间/轨迹序列
				topThrough(doc, body, tj);
			}
		}
		else if	(type==1)	// 移动
		{
			if(!doc.event_obj && glb)
			{
				var objs		= getExtLinks(doc, glb.banBMD, glb.banUrl, glb.banTit);		// 此处所谓的获取外部链接，事实上包含了内部的某些点击响应事件和外部链接
				if(objs.length==0)
					return ;
				
				doc.event_obj	= objs[parseInt(getRandom(0, objs.length - 1 ))];		// 取任意一个对象
			}
			
			var time_len	= getRandom(100, 600);			// 随机时间长度
			var rc			= rcSide2Side(doc.event_obj);	// 从矩形边上的point到边上的point，返回array(from_x, from_y, to_x, to_y)
			if(rc!=null)
			{
				var fm			= {x: rc.fm_x, y: rc.fm_y};
				var to			= {x: rc.to_x, y: rc.to_y};
	
				var tj			= makeTimeTrajectory(time_len, screen_fm, fm, to);		// 产生时间/轨迹序列
				topThrough(doc, doc.event_obj, tj);// (穿过)
			}
		}
		else// 最后一步点击
		{
			if(doc.event_obj)
			{
				var time_len	= getRandom(100, 600);				// 随机时间长度
				var rc			= rcSide2Side(doc.event_obj);		// 从矩形边上的point到边上的point，返回array(from_x, from_y, to_x, to_y)
				//if(rc!=null)
				var fm			= {x: rc.fm_x, y: rc.fm_y};
				var to			= {x: rc.to_x, y: rc.to_y};
				var tj			= makeTimeTrajectory(time_len, screen_fm, fm, to);		// 产生时间/轨迹序列
				topEntry_Click(doc, doc.event_obj, tj);
				//f_logs('click.txt', var_dump_ergodic(doc.event_obj));
			}
		}
	}, lingerTime);
};








var topPosition	= docAbsPosition();						// 文档起点位于屏幕的绝对位置







