// https://developer.mozilla.org/en-US/docs/Extensions/Thunderbird/HowTos/Common_Thunderbird_Use_Cases/View_Message
// 参考：mason
// http://blog.csdn.net/ictextr9/article/details/7165084
// http://www.oschina.net/code/explore/sardine-4.0b7/netwerk/test/TestThreadedIO.cpp


// Helper function for XPCOM instanciation (from Firebug)
function CCIN(cName, ifaceName) {
    return Components.classes[cName].createInstance(Components.interfaces[ifaceName]);
}

// Copy response listener implementation.
function TracingListener( contentLength )
{
	this.dl					= contentLength; 
    this.originalListener	= null;
}

TracingListener.prototype =
{
	dl: 0,
	delivered: false,
	_isShield: false,
    onDataAvailable: function(request, context, inputStream, offset, count)
    {
    	//var httpChannel = request.QueryInterface(Components.interfaces.nsIHttpChannel);
    	//alert(httpChannel.URI.asciiSpec);
    	/*
    	var binaryInputStream	= CCIN('@mozilla.org/binaryinputstream;1',	'nsIBinaryInputStream');
		var storageStream		= CCIN('@mozilla.org/storagestream;1',		'nsIStorageStream');
		var binaryOutputStream	= CCIN('@mozilla.org/binaryoutputstream;1',	'nsIBinaryOutputStream');
		
		binaryInputStream.setInputStream(inputStream);
		storageStream.init(65536, count, null);
		binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));
		
		// Copy received original as they come.
		var original = binaryInputStream.readBytes(count);

		if(ptIsSardineAgent==false)
		{
			original = original.replace(/window.opera/g, '(8==9)');
			original = original.replace(/\(isIE\)/g, '(!isIE)');
			original = original.replace(/\(baidu.ie\)/g, '(!baidu.ie)');
		}
		count	= original.length;
		
		
	
		//alert(request.originalURI.asciiSpec);
		//aRequest.cancel(Cr.NS_ERROR_ABORT);
		
		binaryOutputStream.writeBytes(original, count);
		try{
			this.originalListener.onDataAvailable(request, context, storageStream.newInputStream(0), offset, count);
		}catch(e){}*/
    },
    
    visitHeader : function ( aHeader, aValue )
    {
    	// 参看火狐nsMimeTypes.h
    	if( aHeader.indexOf( 'Content-Type' )>=0	&& 
        	(  (aValue.indexOf( 'application/' )	>=0 && (aValue.indexOf('javascript')<0 && aValue.indexOf('json')<0)	) ||
        		aValue.indexOf( 'text/vnd.wap.wml' )>=0 ||	// wap.wml火狐不能解析
        		aValue.indexOf( 'audio/' )			>=0 ||
        		aValue.indexOf( 'video/')			>=0 /*||
        		aValue.indexOf( 'image/')			>=0*/
        	)
        )
    	{
    		this._isShield = true;
    	}
    	else if(aHeader.indexOf( 'WWW-Authenticate' )>=0)	// 401错误，提示验证
    	{
    		this._isShield = true;
    	}
    },
    
    isShield : function ( )
    {
    	return this._isShield;
    },

    onStartRequest: function(request, context)
    {
    	try
    	{
    		this.originalListener.onStartRequest(request, context);
    	}catch(e){	}
    },

    onStopRequest: function(request, context, statusCode)
    {
    	try
    	{
    		this.originalListener.onStopRequest(request, context, statusCode);
    	}catch(e){	}
    },

	QueryInterface: function (aIID)
	{
		if (aIID.equals(Components.interfaces.nsIStreamListener) ||
			aIID.equals(Components.interfaces.nsISupports)) {
			return this;
		}else{
			throw Components.results.NS_NOINTERFACE;
		}
	}
};



//-------------------------------------------------------------------------------------------------------------------
//		屏蔽网址
//-------------------------------------------------------------------------------------------------------------------
var httpRequestObserver =
{
	observe: function(subject, topic, data)
	{   
		var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
		if 		(topic == 'http-on-modify-request')
		{
			if (!(subject instanceof Components.interfaces.nsIHttpChannel))
				return;
				
			
			//if(url.indexOf('http://www.taobao.com/webww/')==0 )	subject.cancel(Components.results.NS_BINDING_ABORTED);
		}
		else if	(topic == 'http-on-examine-response' || topic == 'http-on-examine-merged-response' || topic == 'http-on-examine-cached-response')
		{
			if ( subject instanceof Components.interfaces.nsIHttpChannel)
			{
				var newListener = new TracingListener(subject.contentLength);
				subject.visitResponseHeaders( newListener );	// 过滤Content-Type
				
				//subject.QueryInterface(Components.interfaces.nsITraceableChannel);	// 过滤内容
				//newListener.originalListener = subject.setNewListener(newListener);
				if ( newListener.isShield() )
					subject.cancel(Components.results.NS_BINDING_ABORTED);
			}
		}
	},
 
	get observerService()
	{
		return Components.classes['@mozilla.org/observer-service;1'].getService(Components.interfaces.nsIObserverService);
	},

	register: function()
	{
		this.observerService.addObserver(this, 'http-on-modify-request', false);				// http请求修改
		this.observerService.addObserver(this, 'http-on-examine-response', false);				// http 檢驗回應
		this.observerService.addObserver(this, 'http-on-examine-merged-response', false);		// 合并回应
		this.observerService.addObserver(this, 'http-on-examine-cached-response', false);
	},
 
	unregister: function()
	{
		this.observerService.removeObserver(this, 'http-on-modify-request');
		this.observerService.removeObserver(this, 'http-on-examine-response');
		this.observerService.removeObserver(this, 'http-on-examine-merged-response');
		this.observerService.removeObserver(this, 'http-on-examine-cached-response');
	}
};



httpRequestObserver.register();							// (gecko.js)修改网页内容，屏蔽urls





